﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Tracker
{

    public class TrackerFull
    {
        public End_Device_Ids? end_device_ids { get; set; }
        public string[]? correlation_ids { get; set; }
        public string? received_at { get; set; }
        public Uplink_Message? uplink_message { get; set; }
    }

    public class End_Device_Ids
    {
        public string? device_id { get; set; }
        public Application_Ids? application_ids { get; set; }
        public string? dev_eui { get; set; }
        public string? join_eui { get; set; }
        public string? dev_addr { get; set; }
    }

    public class Application_Ids
    {
        public string? application_id { get; set; }
    }

    public class Uplink_Message
    {
        public string? session_key_id { get; set; }
        public int f_port { get; set; }
        public int f_cnt { get; set; }
        public string? frm_payload { get; set; }
        public Decoded_Payload? decoded_payload { get; set; }
        public Rx_Metadata[]? rx_metadata { get; set; }
        public Settings? settings { get; set; }
        public string? received_at { get; set; }
        public string? consumed_airtime { get; set; }
        public Locations? locations { get; set; }
        public Version_Ids? version_ids { get; set; }
        public Network_Ids? network_ids { get; set; }
    }

    public class Decoded_Payload
    {
        public bool ALARM_status { get; set; }
        public float BatV { get; set; }
        public int FW { get; set; }
        public bool LON { get; set; }
        public string? MD { get; set; }
        public float latitude { get; set; }
        public float longitude { get; set; }
    }

    public class Settings
    {
        public Data_Rate? data_rate { get; set; }
        public string? coding_rate { get; set; }
        public string? frequency { get; set; }
    }

    public class Data_Rate
    {
        public Lora? lora { get; set; }
    }

    public class Lora
    {
        public int bandwidth { get; set; }
        public int spreading_factor { get; set; }
    }

    public class Locations
    {
        public FrmPayload? frmpayload { get; set; }
    }

    public class FrmPayload
    {
        public float latitude { get; set; }
        public float longitude { get; set; }
        public string? source { get; set; }
    }

    public class Version_Ids
    {
        public string? brand_id { get; set; }
        public string? model_id { get; set; }
        public string? hardware_version { get; set; }
        public string? firmware_version { get; set; }
        public string? band_id { get; set; }
    }

    public class Network_Ids
    {
        public string? net_id { get; set; }
        public string? tenant_id { get; set; }
        public string? cluster_id { get; set; }
        public string? cluster_address { get; set; }
    }

    public class Rx_Metadata
    {
        public Gateway_Ids? gateway_ids { get; set; }
        public Packet_Broker? packet_broker { get; set; }
        public DateTime time { get; set; }
        public int rssi { get; set; }
        public int signal_rssi { get; set; }
        public int channel_rssi { get; set; }
        public int rssi_standard_deviation { get; set; }
        public float snr { get; set; }
        public string? frequency_offset { get; set; }
        public string? uplink_token { get; set; }
        public string? received_at { get; set; }
    }

    public class Gateway_Ids
    {
        public string? gateway_id { get; set; }
    }

    public class Packet_Broker
    {
        public string? message_id { get; set; }
        public string? forwarder_net_id { get; set; }
        public string? forwarder_tenant_id { get; set; }
        public string? forwarder_cluster_id { get; set; }
        public string? forwarder_gateway_id { get; set; }
        public string? home_network_net_id { get; set; }
        public string? home_network_tenant_id { get; set; }
        public string? home_network_cluster_id { get; set; }
    }

}
